/*
    create on base zipdemo.prg part of HMG samples
*/

#include "hmg.ch"

Function do_backup()

open_backup()
if chk_backup()
   return 
endif

	DEFINE WINDOW backup_1 ; 
		AT 114,218 ;
		WIDTH 400 ;
		HEIGHT 300 ; 
		TITLE 'Create Backup' ; 
		MODAL ;
      ON INIT CreateZip()
		
		@ 80,120 PROGRESSBAR Progress_1 RANGE 0,20 SMOOTH

		@ 120,120 LABEL label_1 VALUE ''

	END WINDOW 

	backup_1.center
	backup_1.activate

Return NIL
*------------------------------------------------------------------------------*
Function CreateZip()
*------------------------------------------------------------------------------*
local aDir:=Directory("*.dbf")
local afiles:={}
Local x
local nLen

	For x:=1 to len(aDir)
	    aadd(afiles,adir[x,1])
	next

   use _backup
   _folder := alltrim(destinate)
   _zipname := alltrim(name)
   _day := alltrim(str(dow( date() )))
                
   _zipfile := _folder + '\' + _zipname + _day + '.zip'
  
   /* destination filder MUST EXIST, compress not create folder, only file */
  
   *msginfo('Create ' + _zipfile) 
  
	COMPRESS afiles ;
		TO _zipfile ;
		BLOCK {|cFile,nPos| ProgressUpdate( nPos , cFile ) }  ;
		OVERWRITE

     inkey(1) 
 
     use _backup
     replace datum with date()
     use

     backup_1.release      
      
Return nil
*------------------------------------------------------------------------------*
function ProgressUpdate(nPos , cFile )
*------------------------------------------------------------------------------*

	backup_1.Progress_1.Value := nPos
	backup_1.Label_1.Value := cFile
   inkey(.1)
   
Return Nil
*:*************************************************
FUNCTION open_backup ()

LOCAL alist_fld
if ! file ("_backup.dbf")
   alist_fld := {} 
   aadd(alist_fld,{"DATUM","D",8,0})       
   aadd(alist_fld,{"DESTINATE","C",60,0})
   aadd(alist_fld,{"NAME","C",10,0})
   dbcreate("_backup",alist_fld)
endif

use _backup
if reccount() < 1
   dbappend()
   replace datum with date()-3       // date of last backup
   replace destinate with 'c:\backup'   // destination folder
   replace name with 'test'          // backup name
endif

dbcloseall()

RETURN 
*:***********************************************
FUNCTION chk_backup()

use _backup
if datum >= date()
   use 
   return .T.
endif
use

RETURN .F.
